"""
Setting for jwt extension.
"""

from flask_jwt_extended import JWTManager

jwt = JWTManager()

def get_response(code=200,status=True,message=''):
    """
    Generate standar response format.
    Parameters:
    -----
    code:int
        HTTP Status Code.
    status:bool
        Response status, True if no error.
    message:str
        Response message.
    Returns:
    -----
        Response object as dictionary along with its status code.
    """
    response = {'code':code,'status':status,'message':message,'data':{}}
    return response,code

@jwt.expired_token_loader
def expired_token_callback(expired_token):
    """
    Generate response for expired token.
    Parameters:
    -----
    expired_token:dict
        Expired token data that has been determined as expired.
    Returns:
        Response using get_response method.
    """
    token_type = expired_token['type']
    return get_response(code=401,status=False,message=f'The {token_type} token has expired.')


@jwt.unauthorized_loader
def unauthorized_callback(error_message):
    """
    Generate response for unauthorized request.
    Parameters:
    -----
    error_message:str
        Error message for unaunthorized request, generated by flask jwt extended.
    Returns:
        Response using get_response method.
    """
    return get_response(code=401,status=False,message=error_message)


@jwt.invalid_token_loader
def invalid_token_callback(error_message):
    """
    Generate response for invalid Authorization token in request.
    Parameters:
    -----
    error_message:str
        Error message for invalid Authorization token in request, generated by flask jwt extended.
    Returns:
        Response using get_response method.
    """
    return get_response(code=422,status=False,message=error_message)
